<?php

function WpPopupPluginPageExec(){
	global $wpdb;
	$table_name = "wp_popup_plugin_content";
	
	global $blog_id;
	if(!$blog_id){
		$blog_id = 'no_id';
	}
	
	$url = new Popup_Urls();
	$popup_name = '';
	$popup_content = '';
	$popup_regularity = 50;
	$popup_status = '';
	$popup_stop_date = '';
	$popup_width = 520;
	$popup_animation = 'fade';
	$popup_pages_to_display_on = 'all_pages';
	$popup_urls = '';
	$popup_regularity_type = 'percentage';
	$popup_regularity_x = 1;
	$popup_regularity_period = 'day';
	$error_msg = '';
	$success_msg = '';
	$id = null;
	
	$action = 'list';
	if(isset($_GET['popup_admin_action']) AND $_GET['popup_admin_action'] != ''){
		$action = $_GET['popup_admin_action'];
	}
	
	if(isset($_GET['popup_admin_item_id']) AND $_GET['popup_admin_item_id'] != ''){
		$id = intval($_GET['popup_admin_item_id']);
	}
	
	if(isset($_POST['delete']) AND $id != null){
		$wpdb->query("DELETE FROM $table_name WHERE id = $id");
		$success_msg = __('Custom Popup Deleted','wp_popup_plugin');
		$action = 'list';
	}
	
	if(isset($_POST['save_publish']) OR isset($_POST['save_only'])){
		$values = array();
		$format = array();
		
		if(!isset($_POST['name']) OR $_POST['name'] == ''){
			$error_msg .= __(' Name is required.','wp_popup_plugin');
		}else{
			$popup_name = stripslashes($_POST['name']);
			$values['name'] = stripslashes($_POST['name']);
			$format[] = "%s";
		}
		
		if(!isset($_POST['popup_content']) OR $_POST['popup_content'] == ''){
			$error_msg .= __(' Content is required.','wp_popup_plugin');
		}else{
			$popup_content = stripslashes($_POST['popup_content']);
			$values['content'] = stripslashes($_POST['popup_content']);
			$format[] = "%s";
		}
		
		if(!isset($_POST['popup_regularity_type']) OR $_POST['popup_regularity_type'] == ''){
			$error_msg .= __(' Regularity is required.','wp_popup_plugin');
		}else{
			$popup_regularity_type = $_POST['popup_regularity_type'];
			$values['regularity_type'] = $_POST['popup_regularity_type'];
			$format[] = "%s";
			
			if($popup_regularity_type == 'percentage'){
				if(!isset($_POST['regularity']) OR $_POST['regularity'] == ''){
					$error_msg .= __(' You need to select a value on the slider.','wp_popup_plugin');
				}else{
					$popup_regularity = ceil($_POST['regularity']);
					$values['regularity'] = ceil($_POST['regularity']);
					$format[] = "%d";
				}
			}elseif($popup_regularity_type == 'x_per'){
				if(!isset($_POST['popup_regularity_x']) OR $_POST['popup_regularity_x'] == ''){
					$error_msg .= __(' You need to input a number for regularity.','wp_popup_plugin');
				}else{
					$popup_regularity_x = intval($_POST['popup_regularity_x']);
					$values['regularity'] = intval($_POST['popup_regularity_x']);
					$format[] = "%d";
				}
				
				if(!isset($_POST['popup_regularity_period']) OR $_POST['popup_regularity_period'] == ''){
					$error_msg .= __(' You need to select a regularity period (day,week,month).','wp_popup_plugin');
				}else{
					$popup_regularity_period = $_POST['popup_regularity_period'];
					$values['regularity_period'] = $_POST['popup_regularity_period'];
					$format[] = "%s";
				}
			}
		}
		
		if(!isset($_POST['popup_width']) OR $_POST['popup_width'] == ''){
			$values['width'] = 520;
			$format[] = "%d";
		}else{
			$popup_width = intval($_POST['popup_width']);
			$values['width'] = intval($_POST['popup_width']);
			$format[] = "%d";
		}
		
		if(!isset($_POST['popup_animation']) OR $_POST['popup_animation'] == ''){
			$values['animation'] = 'fade';
			$format[] = "%s";
		}else{
			$popup_animation = $_POST['popup_animation'];
			$values['animation'] = $_POST['popup_animation'];
			$format[] = "%s";
		}
		
		if(!isset($_POST['popup_pages_to_display_on']) OR $_POST['popup_pages_to_display_on'] == ''){
			$values['pages_to_display_on'] = 'all_pages';
			$format[] = "%s";
		}else{
			$popup_pages_to_display_on = $_POST['popup_pages_to_display_on'];
			$values['pages_to_display_on'] = $_POST['popup_pages_to_display_on'];
			$format[] = "%s";
			if($_POST['popup_pages_to_display_on'] == 'specific_pages'){
				if(!isset($_POST['popup_urls']) OR $_POST['popup_urls'] == ''){
					$error_msg .= __(' The urls for the pages to display the popup on are required.','wp_popup_plugin');
				}else{
					$popup_urls = $_POST['popup_urls'];
					$values['urls'] = $_POST['popup_urls'];
					$format[] = "%s";
				}
			}else{
				$popup_urls = '';
				$values['urls'] = '';
				$format[] = "%s";
			}
		}
		
		if($error_msg == ''){
			if(!isset($_POST['datepicker']) OR $_POST['datepicker'] == '' OR strtotime(stripslashes($_POST['datepicker'])) == 0){
				$values['stop_date'] = '';
				$format[] = "%s";
			}else{
				$popup_stop_date = stripslashes($_POST['datepicker']);
				$values['stop_date'] = date('Y-m-d H:i:s', strtotime(stripslashes($_POST['datepicker'])));
				$format[] = "%s";
			}
			
			if($action == 'edit' AND $id != null){
				if(isset($_POST['deactivate'])){
					$values['status'] = 'inactive';
					$format[] = "%s";
					$popup_status = 'inactive';
				}
				
				if(isset($_POST['save_publish'])){
					$values['status'] = 'published';
					$format[] = "%s";
					$popup_status = 'published';
				}
				
				
				$wpdb->update($table_name, $values, array('id'=>$id), $format);
				$success_msg = __('Custom Popup Saved','wp_popup_plugin');
			}else{
			
			
				$values['created_on'] = date('Y-m-d H:i:s');
				$format[] = "%s";
				
				$values['blog_id'] = $blog_id;
				$format[] = "%s";
			
				if(isset($_POST['save_publish'])){
					$values['status'] = 'published';
					$popup_status = 'published';
				}else{
					$values['status'] = 'inactive';
					$popup_status = 'inactive';
				}
				$format[] = "%s";
			
				if($wpdb->insert($table_name, $values, $format)){
					$id = $wpdb->insert_id;
					$action = 'edit';
					$success_msg = __('Custom Popup Saved','wp_popup_plugin');
				}else{
					$error_msg .= __(' An unknown error occured. Please try again.','wp_popup_plugin');
				}
			
			}
		}
	}
	
	if($action == 'edit' AND $id != null){
		$popup = $wpdb->get_row("SELECT * FROM $table_name WHERE id = $id ORDER BY id DESC LIMIT 0,1");
		if($popup){
			$popup_name = $popup->name;
			$popup_content = $popup->content;
			$popup_regularity_type = $popup->regularity_type;
			if($popup->regularity_type == 'percentage'){
				$popup_regularity = $popup->regularity;
			}elseif($popup->regularity_type == 'x_per'){
				$popup_regularity_x = $popup->regularity;
				$popup_regularity_period = $popup->regularity_period;
			}
			$popup_status = $popup->status;
			$popup_width = $popup->width;
			$popup_animation = $popup->animation;
			$popup_pages_to_display_on = $popup->pages_to_display_on;
			$popup_urls = $popup->urls;
			if($popup->stop_date AND $popup->stop_date != '' AND strtotime($popup->stop_date) > 1){
				$popup_stop_date = date(get_option('date_format'), strtotime($popup->stop_date));
			}
		}
	}else{
		$action == 'list';
	}
	?>
	<div class="wrap" style="padding: 20px;">
	<?php
	
	
	if($action == 'new'){
		require_once('admin_new.php');
	}elseif($action == 'edit'){
		require_once('admin_edit.php');
	}elseif($action == 'support'){
		require_once('admin_support.php');
	}else{
		require_once('admin_list.php');
	}
	
	?>
	</div>
	<?php
}


if (!function_exists("WpPopupPluginPage")) {
	function WpPopupPluginPage() {
		if (function_exists('add_menu_page')) {
			add_menu_page('Custom Popups', 'CustomPopups', 'edit_pages', basename(__FILE__), 'WpPopupPluginPageExec', plugins_url( '/img/info_16.png', __FILE__ ));
		}
	}	
}
add_action('admin_menu', 'WpPopupPluginPage');



function custom_popups_admin_init(){
 	if(isset($_GET['page']) AND $_GET['page'] == 'popup_admin.php'){
 	
 	//wp_deregister_script('jquery');
	//wp_register_script('jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js');
	
	
 	wp_register_style('custom_popups_admin_style_datepicker', plugins_url( '/css/overcast/jquery-ui-1.8.23.custom.css', __FILE__ ), array(), '1', 'screen' );
 	wp_enqueue_style( 'custom_popups_admin_style_datepicker' );
 	wp_register_script('custom_popups_admin_script_datepicker', 'http://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js', array( 'jquery'), '1', false );
 	wp_enqueue_script('custom_popups_admin_script_datepicker');
 	
 	wp_register_style('custom_popups_admin_style_slider', plugins_url( '/css/nouislider.css', __FILE__ ), array(), '1', 'screen' );
 	wp_enqueue_style( 'custom_popups_admin_style_slider' );
 	wp_register_script('custom_popups_admin_script_slider', plugins_url( '/js/jquery.nouislider.min.js', __FILE__ ), array( 'jquery'), '1', false );
 	wp_enqueue_script('custom_popups_admin_script_slider');
 	
 	wp_register_style('custom_popups_admin_style_admin', plugins_url( '/css/wp_popups_admin.css', __FILE__ ), array(), '1', 'screen' );
 	wp_enqueue_style( 'custom_popups_admin_style_admin' );
 	}
}
add_action('admin_init', 'custom_popups_admin_init');
