<?php
if (!function_exists("CurrentUrl")) {
function CurrentUrl(){
	$s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";
	$protocol = substr(strtolower($_SERVER["SERVER_PROTOCOL"]), 0, strpos(strtolower($_SERVER["SERVER_PROTOCOL"]), "/")) . $s;
	$port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);
	return $protocol . "://" . $_SERVER['SERVER_NAME'] . $port . $_SERVER['REQUEST_URI'];
}
}
if (!function_exists("GmailTime")) {
function GmailTime($time = null){
		if(!$time)
			$time = date('Y-m-d H:i:s');
	
		$time = strtotime($time);
	
		if(intval(date("Y")) > intval(date("Y", $time))){
			return date(get_option('date_format'), $time);
		}elseif(floor(time() - $time) > (24 * 60 * 60)){
			return date(get_option('date_format'), $time);
		}else{
			return date(get_option('time_format'), $time);
		}
}
}

if (!function_exists("dateStringToDatepickerFormat")) {
function dateStringToDatepickerFormat($dateString)
{
	$pattern = array(
		
		//day
		'd',		//day of the month
		'j',		//3 letter name of the day
		'l',		//full name of the day
		'z',		//day of the year
		
		//month
		'F',		//Month name full
		'M',		//Month name short
		'n',		//numeric month no leading zeros
		'm',		//numeric month leading zeros
		
		//year
		'Y', 		//full numeric year
		'y'		//numeric year: 2 digit
	);
	$replace = array(
		'dd','d','DD','o',
		'MM','M','m','mm',
		'yy','y'
	);
	foreach($pattern as &$p)
	{
		$p = '/'.$p.'/';
	}
	return preg_replace($pattern,$replace,$dateString);
}
}

class Popup_Urls {
	var $base = '';
	
	function Popup_Urls(){
		$this->base = CurrentUrl();
		if(isset($_GET['popup_admin_action'])){
			$this->base = str_replace('&popup_admin_action=' . $_GET['popup_admin_action'] , '', $this->base);
		}
		if(isset($_GET['popup_admin_page'])){
			$this->base = str_replace('&popup_admin_page=' . $_GET['popup_admin_page'] , '', $this->base);
		}
		if(isset($_GET['popup_admin_item_id'])){
			$this->base = str_replace('&popup_admin_item_id=' . $_GET['popup_admin_item_id'] , '', $this->base);
		}
	}
	
	function CurrentUrl(){
		$s = empty($_SERVER["HTTPS"]) ? '' : ($_SERVER["HTTPS"] == "on") ? "s" : "";
		$protocol = substr(strtolower($_SERVER["SERVER_PROTOCOL"]), 0, strpos(strtolower($_SERVER["SERVER_PROTOCOL"]), "/")) . $s;
		$port = ($_SERVER["SERVER_PORT"] == "80") ? "" : (":".$_SERVER["SERVER_PORT"]);
		return $protocol . "://" . $_SERVER['SERVER_NAME'] . $port . $_SERVER['REQUEST_URI'];
	}
	
	function AddNew(){
		return $this->base . "&popup_admin_action=new";
	}
	
	function Edit($id){
		return $this->base . "&popup_admin_action=edit&popup_admin_item_id=$id";
	}
	
	function ListAll(){
		return $this->base;
	}
	
	function PreviewUrl($id){
		$home = home_url();
		if(parse_url($home, PHP_URL_QUERY)){
			return $home . '&popup_preview='.$id;
		}else{
			return $home . '?popup_preview='.$id;
		}
	}
	
	function Support(){
		return $this->base . "&popup_admin_action=support";
	}
}
if (!function_exists("paginate_three")) {
function paginate_three($reload, $page, $tpages, $adjacents = 3) {
	
	$out = "<p> <span class=\"paginition2\">Pages:</span> ";
	
	// first
	if($page>($adjacents+1)) {
		$out.= "<a class=\"paginition\" href=\"$reload\" rel=\"1\">1</a>";
	}
	
	// interval
	if($page>($adjacents+2)) {
		$out.= "<span class=\"paginition\">...</span>";
	}
	
	// pages
	$pmin = ($page>$adjacents) ? ($page-$adjacents) : 1;
	$pmax = ($page<($tpages-$adjacents)) ? ($page+$adjacents) : $tpages;
	for($i=$pmin; $i<=$pmax; $i++) {
		if($i==$page) {
			$out.= "<span class=\"paginition\">$i</span>";
		}else {
			$out.= "<a class=\"paginition\" href=\"$reload&popup_admin_page=$i\" >$i</a>";
		}
	}
	
	// interval
	if($page<($tpages-$adjacents-1)) {
		$out.= "<span class=\"paginition\">...</span>";
	}
	
	// last
	if($page<($tpages-$adjacents)) {
		$out.= "<a class=\"paginition\" href=\"$reload&popup_admin_page=$tpages\" >$tpages</a>";
	}
	
	$out.= "</p>";
	
	return $out;
}
}

if (!class_exists("Cookie")) {
class Cookie {
	const Session = null;
	const OneDay = 86400;
	const SevenDays = 604800;
	const ThirtyDays = 2592000;
	const SixMonths = 15811200;
	const OneYear = 31536000;
	const Lifetime = -1; // 2030-01-01 00:00:00

  /**
   * Returns true if there is a cookie with this name.
   *
   * @param string $name
   * @return bool
   */
	static public function Exists($name){
		return isset($_COOKIE[$name]);
	}

  /**
   * Returns true if there no cookie with this name or it's empty, or 0,
   * or a few other things. Check http://php.net/empty for a full list.
   *
   * @param string $name
   * @return bool
   */
	static public function IsEmpty($name){
		return empty($_COOKIE[$name]);
	}

  /**
   * Get the value of the given cookie. If the cookie does not exist the value
   * of $default will be returned.
   *
   * @param string $name
   * @param string $default
   * @return mixed
   */
	static public function Get($name, $default = ''){
		return (isset($_COOKIE[$name]) ? $_COOKIE[$name] : $default);
	}

  /**
   * Set a cookie. Silently does nothing if headers have already been sent.
   *
   * @param string $name
   * @param string $value
   * @param mixed $expiry
   * @param string $path
   * @param string $domain
   * @return bool
   */
	static public function Set($name, $value, $expiry = self::OneYear, $path = '/', $domain = false){
		$retval = false;
		if(!headers_sent()){
			if($domain === false){
				$domain = $_SERVER['HTTP_HOST'];
			}

			if($expiry === -1){
				$expiry = 1893456000; // Lifetime = 2030-01-01 00:00:00
			}elseif(is_numeric($expiry)){
				$expiry += time();
			}else{
				$expiry = strtotime($expiry);
			}

			$retval = @setcookie($name, $value, $expiry, $path, $domain);
			if ($retval){
				$_COOKIE[$name] = $value;
			}
		}
		return $retval;
	}

  /**
   * Delete a cookie.
   *
   * @param string $name
   * @param string $path
   * @param string $domain
   * @param bool $remove_from_global Set to true to remove this cookie from this request.
   * @return bool
   */
	static public function Delete($name, $path = '/', $domain = false, $remove_from_global = false){
		$retval = false;
		if(!headers_sent()){
			if($domain === false){
				$domain = $_SERVER['HTTP_HOST'];
			}
			$retval = setcookie($name, '', time() - 3600, $path, $domain);
			if($remove_from_global){
				unset($_COOKIE[$name]);
			}
		}
		return $retval;
	}
}
}
